import { ShallowMapping } from "@wormhole-foundation/sdk-base";
export declare const bamPayloads: readonly [readonly ["BamMessage", readonly [{
    readonly name: "magicByte";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 187;
    readonly omit: true;
}, {
    readonly name: "version";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 0;
    readonly omit: true;
}, {
    readonly name: "type";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 0;
    readonly omit: true;
}, {
    readonly name: "index";
    readonly binary: "uint";
    readonly size: 8;
}, {
    readonly custom: {
        to: (val: number) => "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia";
        from: (val: "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia") => number;
    };
    readonly binary: "uint";
    readonly size: 2;
    readonly name: "targetChain";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "targetAddress";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "senderAddress";
}, {
    readonly custom: any;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
} | {
    readonly custom?: undefined;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
}]], readonly ["BamTokenMessage", readonly [{
    readonly name: "magicByte";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 187;
    readonly omit: true;
}, {
    readonly name: "version";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 0;
    readonly omit: true;
}, {
    readonly name: "type";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 1;
    readonly omit: true;
}, {
    readonly name: "index";
    readonly binary: "uint";
    readonly size: 8;
}, {
    readonly custom: {
        to: (val: number) => "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia";
        from: (val: "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia") => number;
    };
    readonly binary: "uint";
    readonly size: 2;
    readonly name: "targetChain";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "targetAddress";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "senderAddress";
}, {
    readonly custom: any;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
} | {
    readonly custom?: undefined;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
}, {
    readonly custom: any;
    readonly name: "bridge";
    readonly binary: "uint";
    readonly size: 1;
} | {
    readonly custom?: undefined;
    readonly name: "bridge";
    readonly binary: "uint";
    readonly size: 1;
}, {
    readonly custom: any;
    readonly name: "assetIdentifier";
    readonly binary: "uint";
    readonly size: 2;
} | {
    readonly custom?: undefined;
    readonly name: "assetIdentifier";
    readonly binary: "uint";
    readonly size: 2;
}, {
    readonly binary: "uint";
    readonly size: 32;
    readonly name: "amount";
}]], readonly ["BamExtendedMessage", readonly [{
    readonly name: "magicByte";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 187;
    readonly omit: true;
}, {
    readonly name: "version";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 0;
    readonly omit: true;
}, {
    readonly name: "type";
    readonly binary: "uint";
    readonly size: 1;
    readonly custom: 2;
    readonly omit: true;
}, {
    readonly name: "index";
    readonly binary: "uint";
    readonly size: 8;
}, {
    readonly custom: {
        to: (val: number) => "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia";
        from: (val: "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia") => number;
    };
    readonly binary: "uint";
    readonly size: 2;
    readonly name: "targetChain";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "targetAddress";
}, {
    readonly binary: "bytes";
    readonly lengthSize: 2;
    readonly name: "senderAddress";
}, {
    readonly custom: any;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
} | {
    readonly custom?: undefined;
    readonly name: "contents";
    readonly binary: "bytes";
    readonly lengthSize: 2;
}, {
    readonly custom: any;
    readonly name: "relaySignal";
    readonly binary: "bytes";
    readonly lengthSize: 2;
} | {
    readonly custom?: undefined;
    readonly name: "relaySignal";
    readonly binary: "bytes";
    readonly lengthSize: 2;
}]]];
declare global {
    namespace Wormhole {
        interface PayloadLiteralToDescriptionMapping extends ShallowMapping<typeof bamPayloads> {
        }
    }
}
//# sourceMappingURL=bam.d.ts.map